#include <string>
#include <tulip/BooleanProperty.h>
#include <tulip/StableIterator.h>
#include "CleanGraph.h"

using namespace tlp;
using namespace std;

//=====================================================================
void delEdgeSelection (Graph *cleanGraph, BooleanProperty &elementSelected) {
  StableIterator<edge> itE(elementSelected.getEdgesEqualTo (true));
  while(itE.hasNext()) cleanGraph->delEdge(itE.next());
}//end delSelection

//=====================================================================
bool cleanGraph (Graph *cleanGraph) {
  string errMsg;
  BooleanProperty loops (cleanGraph);
  loops.setAllNodeValue (false);
  loops.setAllEdgeValue (false);
  DataSet localData;
  bool success = cleanGraph->computeProperty ("Loop Selection", 
					      &loops, errMsg,
					      NULL, &localData);
  if (!success) {
    cerr << "Loop selection plugin not found." << endl;
    return false;
  }//end if
  delEdgeSelection (cleanGraph, loops);

  BooleanProperty multiEdge (cleanGraph);
  multiEdge.setAllNodeValue (false);
  multiEdge.setAllEdgeValue (false);
  success = cleanGraph->computeProperty ("Multiple edge",
					 &multiEdge, errMsg,
					 NULL, &localData);
  if (!success) {
    cerr << "Multi-edge plugin not found." << endl;
    return false;
  }//end if
  delEdgeSelection (cleanGraph, multiEdge);
  return true;
}//end cleanGraph
