/**
 * The following headder file defines the set of default colours used
 * by grouse and default colours and shapes
 */
#include <tulip/Color.h>
#include <qcolor.h>

#ifndef __COLOUR_SHAPE_DEFAULTS_H__
#define __COLOUR_SHAPE_DEFAULTS_H__

//======================================================================
//defines for typical grouse colours
#define GROUSE_BLUE (tlp::Color (37, 89, 193, 255))
#define GROUSE_BROWN (tlp::Color (157, 86, 74, 255))
#define GROUSE_BROWN_2 (tlp::Color (120, 86, 86, 255))
#define GROUSE_GREEN (tlp::Color (30, 171, 70, 255))
#define GROUSE_PURPLE (tlp::Color (100, 87, 130, 255))
#define GROUSE_MAGENTA (tlp::Color (150, 30, 110, 255))
#define GROUSE_GOLD (tlp::Color (199, 197, 43, 255))
#define GROUSE_TEAL (tlp::Color (5, 199, 215, 255))
#define GROUSE_PINK (tlp::Color (232, 151, 199, 255))
#define GROUSE_RED (tlp::Color (223, 61, 51, 255))
#define GROUSE_DARK_RED (tlp::Color (255, 50, 50, 255))
#define GROUSE_ORANGE (tlp::Color (254, 151, 41))
#define GROUSE_ORANGE_2 (tlp::Color (140, 80, 0))
#define GROUSE_LIGHT_GREY (tlp::Color (155,155,155,255))
#define GROUSE_DARKER_GREY (tlp::Color (180,180,180,255))
#define GROUSE_DARK_GREY (tlp::Color (120,120,120,255))
#define GROUSE_WHITE (tlp::Color (255,255,255,255))
#define GROUSE_BLACK (tlp::Color (0,0,0,255))
 
 //======================================================================     
#define META_NODE_SHAPE (14) //meta nodes are circles
#define LEAF_NODE_SHAPE (1) //leaf nodes are squares
#define META_NODE_BORDER_COLOUR (GROUSE_BLACK) //border colour black
#define LEAF_NODE_BORDER_COLOUR (GROUSE_BLACK) //border colour black
#define META_NODE_BORDER_WIDTH (1.0)
#define LEAF_NODE_BORDER_WIDTH (1.0)

//======================================================================
//defaults for node and edge alpha
#define NODE_ALPHA (255)
#define EDGE_ALPHA (180)

//These define colours to be used by topological features

#define TREE_COLOUR (GROUSE_BLUE) // blue
#define BICONNECTED_COLOUR (GROUSE_BROWN) //brown
#define UNKNOWN_COLOUR (GROUSE_GREEN) // green
#define EMBEDDER_COLOUR (GROUSE_GOLD) //purple
#define STRENGTH_COLOUR (GROUSE_PURPLE) //gold
#define COMPLETE_COLOUR (GROUSE_TEAL) //teal
#define CONNECTED_COLOUR (GROUSE_PINK) //pink

//These define the colours used by leaf nodes and edges
#define LEAF_COLOUR (GROUSE_DARK_GREY) //grey
#define ROOT_COLOUR (GROUSE_LIGHT_GREY)
#define CONN_COMP_COLOUR (GROUSE_DARKER_GREY)
#define EDGE_COLOUR (tlp::Color (210,210,210,EDGE_ALPHA))

//This is the selection colour and line width
#define SELECTION_COLOUR (GROUSE_RED) //red
#define SELECTED_BORDER_WIDTH (4.0) 
#define SELECTED_EDGE_COLOUR (GROUSE_DARK_RED) //trans red

//This is the selection colour
#define PROCESSING_COLOUR (GROUSE_DARK_RED) //red

//This the background colour
#define BACKGROUND_COLOUR (GROUSE_WHITE) //white
#endif
