#include <vector>
#include <string>
#include <tulip/GraphProperty.h>
#include "Split.h"
#include "CreateWithSelection.h"

class CreateAcrossBoundaries {
  
 public:
  CreateAcrossBoundaries (GrouseInterfaceData *grouseMainWidget,
			  tlp::Graph *displayGraph,
			  tlp::Graph *hierarchy,
			  tlp::Graph *hierarchySubGraphs,
			  OpenCloseHierarchy *openCloseHierarchy,
			  const string &metaGraphPropertyName);
  ~CreateAcrossBoundaries ();
  bool mergeAcrossBoundaries (tlp::BooleanProperty &splitSelection,
			      std::vector<tlp::node> &newHierarchyNodes);

 private:
  tlp::Graph *displayGraph;
  tlp::Graph *hierarchy;
  tlp::Graph *hierarchySubGraphs;
  OpenCloseHierarchy *openCloseHierarchy;
  Split *split;
  CreateWithSelection *createWithSelection;
  tlp::GraphProperty *hierarchyMetaGraphs;

  bool splitAndMerge (std::vector<tlp::node> &lcaHierarchyNodes,
		      std::vector<tlp::Graph *> &newDisplaySubGraphs,
		      std::vector<tlp::node> &newHierarchyNodes);
  bool findLCAs (tlp::Graph *mergeGraph, std::vector<tlp::node> &lcas,
		 std::vector<tlp::Graph *> &newDisplaySubGraphs);
  tlp::node componentLCA (tlp::Graph *curComp);
};
