#ifndef SELECTIONWIDGET_H
#define SELECTIONWIDGET_H
#include <string>
#include <tulip/Graph.h>
#include <tulip/AbstractProperty.h>
#include <tulip/BooleanProperty.h>
#include <tulip/StringProperty.h>

#if (QT_REL == 4)
#include "tulip/Qt3ForTulip.h"
#endif
#include "FindSelection.h"

class FindSelection {
 public:
  FindSelection(tlp::Graph *graph, tlp::PropertyInterface *property);
  void find(const std::string &searchString, tlp::BooleanProperty *);
  void findCaptureText (const std::string &searchString,
			tlp::StringProperty *bracketMatchProperty);
 private:
  tlp::Graph *graph;
  tlp::PropertyInterface *property;
  void evalNodes(const std::string &, tlp::BooleanProperty *);
  void evalBracketNodes (const std::string &, tlp::StringProperty *);
};

#endif 
