#if (QT_REL == 3)
#include <iostream>

#include <qstringlist.h>
#include <qwidgetplugin.h>
#include <tulip/Graph.h>
#include "GrouseTableWidget.h"

#include "elementtable.xpm"

using namespace std;
using namespace tlp;

class QT_WIDGET_PLUGIN_EXPORT GrouseTableWidgetPlugin : public QWidgetPlugin
{
public:
  GrouseTableWidgetPlugin();
  ~GrouseTableWidgetPlugin();
  
  QStringList keys() const;
  QWidget* create( const QString &classname, QWidget* parent = 0, const char* name = 0 );
  QString group( const QString& ) const;
  QIconSet iconSet( const QString& ) const;
  QString includeFile( const QString& ) const;
  QString toolTip( const QString& ) const;
  QString whatsThis( const QString& ) const;
  bool isContainer( const QString& ) const;
};

GrouseTableWidgetPlugin::GrouseTableWidgetPlugin() {}
GrouseTableWidgetPlugin::~GrouseTableWidgetPlugin() {}

QStringList GrouseTableWidgetPlugin::keys() const {
  QStringList list;
  list << "GrouseTableWidget";
  return list;
}

QWidget* GrouseTableWidgetPlugin::create(const QString &key, QWidget* parent, const char* name) {
  if (key == "GrouseTableWidget") 
    return new GrouseTableWidget(parent, name, WStaticContents);
  return 0;
}

QString GrouseTableWidgetPlugin::includeFile(const QString& feature) const {
  if (feature == "GrouseTableWidget") 
    return "tulip/GrouseTableWidget.h";
  return QString::null;
}

QString GrouseTableWidgetPlugin::group(const QString& feature) const {
  if (feature == "GrouseTableWidget")
    return "Tulip";
  return QString::null;
}

QIconSet GrouseTableWidgetPlugin::iconSet(const QString& feature) const {
  if (feature == "GrouseTableWidget") {
    return QIconSet(QPixmap (elementtable_xpm));
  }
  return QIconSet();
}

QString GrouseTableWidgetPlugin::toolTip(const QString& feature) const {
  if (feature == "GrouseTableWidget") 
    return tr("Property table widget for grouse nodes");
  return QString::null;
}

QString GrouseTableWidgetPlugin::whatsThis(const QString& feature) const {
  if (feature == "GrouseTableWidget") 
    return tr("A widget to display properties of nodes in the graph.");
  return QString::null;
}

bool GrouseTableWidgetPlugin::isContainer(const QString& feature) const {
  if (feature == "GrouseTableWidget") return false;
  return false;
}

Q_EXPORT_PLUGIN(GrouseTableWidgetPlugin);

#endif
