
#include <tulip/Color.h>

//Class to store HSV colours
class HSV {
public:
  float h;
  float s;
  float v;
  HSV () {
    this->h = 0;
    this->s = 0;
    this->v = 0;
  } 
  HSV (float h, float s, float v) {
    this->h = h;
    this->s = s;
    this->v = v;
  }
};

/**
 * Converts tulip colour to HSV.
 * \param rgb The RGB tulip colour.
 */
HSV rgb_to_hsv (const tlp::Color &rgb);

/**
 * Converts HSV to tulip Colour
 * \param hsv The HSV colour
 */
tlp::Color hsv_to_rgb (const HSV &hsv);
