
#ifndef __HIERARCHY_NODE_CREATION__
#define __HIERARCHY_NODE_CREATION__
#include <string>
#include <vector>
#include <tulip/Graph.h>
#include <tulip/GraphProperty.h>

void copy (tlp::Graph *src, tlp::Graph *dest);
void delFeature (tlp::Graph *feature, tlp::Graph *delGraph);
void setNewConnections (tlp::Graph *hierarchySubGraph,
			tlp::Graph *newSubGraph,
			const tlp::node &newClusterNode);

/**
 * Method to turn connected components into metanodes.
 * \param curHierarchyGraph The hierarchy graph being processed
 * \param components The desired connected components
 * \param addedHierarchyNodes The nodes added to the graph hierarchy
 * \param errorLocation Location for error in messages.
 */

bool processConnectedComponents (tlp::Graph *curHierarchyGraph,
				 tlp::Graph *components,
				 std::vector<tlp::node> &addedHierarchyNodes,
				 tlp::Graph *hierarchy,
				 tlp::Graph *hierarchySubGraphs,
				 tlp::GraphProperty *hierarchyMetaGraphs,
				 const std::string &errorLocation);
#endif
