#ifndef __MOUSE_GROUSE_BASE_INTERFACE_H__
#define __MOUSE_GROUSE_BASE_INTERFACE_H__
#include <qevent.h>
#include <tulip/GWInteractor.h>
#include <tulip/GlGraphWidget.h>
#include "OpenCloseHierarchy.h"
#include "MetaNodeBoundingCircle.h"
#include "GrouseSelectionProperty.h"


//================================================================
/**
 * The following class sets up the mouse interface for the
 * Grouse project.  The interface maps all mouse clicks to 
 * actions within grouse along with keybord actions as well.
 */
class MouseGrouseBaseNavigate : public GWInteractor {
 public:
  MouseGrouseBaseNavigate(OpenCloseHierarchy *openCloseHierarchy,
			  GrouseSelectionProperty *grouseSelectionProperty);
  ~MouseGrouseBaseNavigate();
  bool eventFilter (QObject *, QEvent *);
  GWInteractor * clone() { 
    return new MouseGrouseBaseNavigate(openCloseHierarchy, 
				       grouseSelectionProperty);
  }

 private:
  QPoint startDrag;
  GrouseSelectionProperty *grouseSelectionProperty;
  OpenCloseHierarchy *openCloseHierarchy;
  static bool inDragState;
  inline void initStartDrag (const QPoint &start) { startDrag = start; }
  void pan (const QPoint &end, GlGraphWidget *graph);
  void select (const QPoint &mouseClick, GlGraphWidget *graphWidget);
  bool mPressEvent(GlGraphWidget *,QMouseEvent *);
  bool mReleaseEvent(GlGraphWidget *,QMouseEvent *);
  bool mMoveEvent(GlGraphWidget *,QMouseEvent *);
  bool keyPressEvent (GlGraphWidget *, QKeyEvent *);
  bool wheelEvent(GlGraphWidget *, QWheelEvent *);
};
#endif
