#ifndef __MOUSE_GROUSE_HIERARCHY_INTERFACE_H__
#define __MOUSE_GROUSE_HIERARCHY_INTERFACE_H__
#include <qevent.h>
#include <tulip/GWInteractor.h>
#include <tulip/GlGraphWidget.h>
#include <tulip/MetaGraphHierarchyWidget.h>
#include "GrouseMorphing.h"
#include "OpenCloseHierarchy.h"
#include "MetaNodeBoundingCircle.h"

//================================================================
/**
 * The following class sets up the mouse interface for the
 * mouse operations to do with hierarchy browsing and selection.
 */
class MouseGrouseHierarchyNavigate : public GWInteractor {
 public:
  MouseGrouseHierarchyNavigate(OpenCloseHierarchy *openCloseHierarchy,
		      MetaGraphHierarchyWidget *metaGraphHierarchy,
		      GrouseMorphing *grouseMorph);
  ~MouseGrouseHierarchyNavigate();
  bool eventFilter (QObject *, QEvent *);
  GWInteractor * clone() { 
    return new MouseGrouseHierarchyNavigate(openCloseHierarchy, 
					    metaGraphHierarchy,
					    grouseMorph);
  }

 private:
  MetaGraphHierarchyWidget *metaGraphHierarchy;
  OpenCloseHierarchy *openCloseHierarchy;
  GrouseMorphing *grouseMorph;
  void openClose (const QPoint &mouseClick, GlGraphWidget *graphWidget,
		  const bool layoutReset);
  void powerOpen (const QPoint &mouseClick,
		  GlGraphWidget *graphWidget);
  bool mPressEvent(GlGraphWidget *,QMouseEvent *);
};
#endif
