#ifndef __MOUSE_GROUSE_PULL_OUT_INTERFACE_H__
#define __MOUSE_GROUSE_PULL_OUT_INTERFACE_H__
#include <qevent.h>
#include <tulip/GWInteractor.h>
#include <tulip/GlGraphWidget.h>
#include "GrouseMorphing.h"

//================================================================
/**
 * The following class sets up the mouse interface for the
 * mouse operations to do with hierarchy browsing and selection.
 */
class MouseGrousePullOut : public GWInteractor {
 public:
  MouseGrousePullOut (GrouseMorphing *grouseMorph);
  ~MouseGrousePullOut ();
  bool eventFilter (QObject *, QEvent *);
  GWInteractor * clone() { 
    return new MouseGrousePullOut (grouseMorph);
  }
  void reset ();

 private:
  GrouseMorphing *grouseMorph;
  void pullInOrPushOut (const QPoint &mouseClick, GlGraphWidget *graphWidget);
  bool mPressEvent(GlGraphWidget *,QMouseEvent *);
};
#endif
