#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <qapplication.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include "QtProgressWidget.h"
#include <tulip/GlGraphWidget.h>
#include <qprogressbar.h>
using namespace std;
using namespace tlp;

//=====================================
QtProgressWidget::QtProgressWidget(QWidget* parent,const char *name, Qt::WFlags fl): QtProgressWidgetData( parent, name, fl) {
}
//=====================================
QtProgressWidget::~QtProgressWidget() {
}
//=====================================
void QtProgressWidget::reset () {
   progressBar->setTotalSteps(1);
   progressBar->setProgress (0);
}

//=====================================
void QtProgressWidget::progress_handler(int i,int j) {
  //  cerr << __PRETTY_FUNCTION__ << endl;
  progressBar->setTotalSteps(j);
  progressBar->setProgress (i);
  if (state()!=TLP_CONTINUE) {
    return;
  }
  qApp->processEvents();
}
//=====================================
void QtProgressWidget::setComment(string msg) {
  qApp->processEvents();
}
//=====================================
void QtProgressWidget::showPreview(bool flag) {
}

//=====================================
void QtProgressWidget::stopCompute(){
  //  cerr << __PRETTY_FUNCTION__ << endl;
  PluginProgress::stop();
  reset ();
}
//=====================================
void QtProgressWidget::cancelCompute(){
  //  cerr << __PRETTY_FUNCTION__ << endl;
  PluginProgress::cancel();
  reset ();
}

//=====================================

void QtProgressWidget::enable_buttons (bool stop, bool cancel) {
  stop_button->setEnabled (stop);
  cancel_button->setEnabled (cancel);
}
