#if (QT_REL == 3)
#include <iostream>

#include <qstringlist.h>
#include <qwidgetplugin.h>
#include <tulip/Graph.h>
#include "QtProgressWidget.h"

#include "metahierarchywidget.xpm"

using namespace std;
using namespace tlp;

class QT_WIDGET_PLUGIN_EXPORT QtProgressPlugin : public QWidgetPlugin
{
public:
  QtProgressPlugin();
  ~QtProgressPlugin();
  
  QStringList keys() const;
  QWidget* create( const QString &classname, QWidget* parent = 0, const char* name = 0 );
  QString group( const QString& ) const;
  QIconSet iconSet( const QString& ) const;
  QString includeFile( const QString& ) const;
  QString toolTip( const QString& ) const;
  QString whatsThis( const QString& ) const;
  bool isContainer( const QString& ) const;
};

QtProgressPlugin::QtProgressPlugin() {}
QtProgressPlugin::~QtProgressPlugin() {}

QStringList QtProgressPlugin::keys() const {
  QStringList list;
  list << "QtProgressWidget";
  return list;
}

QWidget* QtProgressPlugin::create(const QString &key, QWidget* parent, const char* name) {
  if (key == "QtProgressWidget") 
    return new QtProgressWidget(parent, name, WStaticContents);
  return 0;
}

QString QtProgressPlugin::includeFile(const QString& feature) const {
  if (feature == "QtProgressWidget") 
    return "tulip/QtProgressWidget.h";
  return QString::null;
}

QString QtProgressPlugin::group(const QString& feature) const {
  if (feature == "QtProgressWidget")
    return "Tulip";
  return QString::null;
}

QIconSet QtProgressPlugin::iconSet(const QString& feature) const {
  if (feature == "QtProgressWidget") {
    return QIconSet(QPixmap (metahierarchywidget_xpm));
  }
  return QIconSet();
}

QString QtProgressPlugin::toolTip(const QString& feature) const {
  if (feature == "QtProgressWidget") 
    return tr("Qt Progress Widget");
  return QString::null;
}

QString QtProgressPlugin::whatsThis(const QString& feature) const {
  if (feature == "QtProgressWidget") 
    return tr("A widget to display a treeview of a specified metagraph hierarchy.");
  return QString::null;
}

bool QtProgressPlugin::isContainer(const QString& feature) const {
  if (feature == "QtProgressWidget") return false;
  return false;
}

Q_EXPORT_PLUGIN(QtProgressPlugin);

#endif
