#ifndef __DRAW_STEERED_NODE_H__
#define __DRAW_STEERED_NODE_H__
#include <vector>
#include <string>
#include <tulip/Graph.h>
#include <tulip/MutableContainer.h>
#include <tulip/PluginProgress.h>

//true if graph not layed out, false otherwise
#define HAS_LAYOUT_ATTRIBUTE ("noLayout")
#define EDGE_ORDER_ATTRIBUTE ("Edge Order")
#define HDE_ROOT_ATTRIBUTE ("HDE root")

//This type stores the order of edges around each node for repeatable layouts
typedef tlp::MutableContainer<std::vector<tlp::edge> > EdgeOrderTable;

bool drawSteeredNode (tlp::Graph *curSubGraph, tlp::Graph *fatherSubGraph,
		      bool useDefaultAlgorithms, 
		      tlp::PluginProgress *pluginProgress = NULL,
		      std::string useThisAlgorithm = "");

/**
 * Function, given a delGraph, will clear all of its layout parameters.
 */
void clearLayoutParameters (tlp::Graph *delGraph);

void copyOverLayoutParms (tlp::Graph *src, tlp::Graph *dest);

#endif
