//-*-c++-*-
#ifndef _ATTRIBUTE_EQUAL_VALUE_H
#define _ATTRIBUTE_EQUAL_VALUE_H

/** \addtogroup metric */
/*@{*/
/// AttributeMetric.h - A plugin to cluster by string and double attribute
/** 
 * This plugin implements string and double clustering on graph attributes
 * it does so base on exact equal value of the property. 
 *
 *  HISTORY:
 *
 *  02/14/2007 Verson 0.0.1: Initial release
 *
 *  NOTES:
 *
 * 
 *
 *  AUTHOR:
 *
 *  Daniel Archambault - UBC archam@cs.ubc.ca
 *
 *  LICENCE:
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by  
 *  the Free Software Foundation; either version 2 of the License, or     
 *  (at your option) any later version.
 *
 */

#include <tulip/TlpTools.h>
#include <tulip/TulipPlugin.h>

class AttributeEqualValue:public tlp::DoubleAlgorithm
{ 
public:
  AttributeEqualValue (const tlp::PropertyContext &);
  ~AttributeEqualValue();
  bool check(std::string &) { return true; } 
  void reset() {}
  bool run();
  
};
/*@}*/
#endif
