//-*-c++-*-
#ifndef _BICONFILTER_H
#define _BICONFILTER_H

/** \addtogroup metric */
/*@{*/
/// AttributeMetric.h - A plugin to cluster by string and double attribute
/** This plugin implements string and double clustering on graph attributes
 *
 *  HISTORY:
 *
 *  02/12/2007 Verson 0.0.1: Initial release
 *
 *  NOTES:
 *
 * 
 *
 *  AUTHOR:
 *
 *  Daniel Archambault - UBC archam@cs.ubc.ca
 *
 *  LICENCE:
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by  
 *  the Free Software Foundation; either version 2 of the License, or     
 *  (at your option) any later version.
 *
 */

#include <tulip/TlpTools.h>
#include <tulip/TulipPlugin.h>
#include <tulip/Graph.h>

class AttributeMetric:public tlp::DoubleAlgorithm
{ 
public:
  AttributeMetric (const tlp::PropertyContext &);
  ~AttributeMetric();
  inline bool check(std::string &) { return true; } 
  inline void reset() {}
  bool run();
  
private:
  tlp::Graph *trueComponents (tlp::BooleanProperty *selection);
  tlp::Graph *falseComponents (tlp::BooleanProperty *selection);
  bool makeConnected (tlp::Graph *disconnectedGraph,
		      tlp::DoubleProperty &connectedMetric);
  void setupFinalMetric (tlp::Graph *inducedComponents,
			 tlp::DoubleProperty &trueComponents,
			 tlp::Graph *otherComponents,
			 tlp::DoubleProperty &falseComponents);
};
/*@}*/
#endif
